import packages.twoD.Vector;
public class Tire  
{
    public double maxGrip;
    public double minGrip;
    public double slipDelay;
    public int gripLin;
    public Tire(int type){
        if(type==1){//sport
            maxGrip = 4;
            minGrip = 0.3;
            slipDelay = 0.2;
            gripLin = 4;
        }
        else if(type==2){//extreme
            maxGrip = 4;
            minGrip = 0.4;
            slipDelay = 0.3;
            gripLin = 4;
        }
        else{//standart
            maxGrip = 3;
            minGrip = 0.4;
            slipDelay = 1;
            gripLin = 1;
        }
    }
    public Vector getDrag(Vector speed){
        return getDrag(speed, 0);
    }
    public Vector getDrag(Vector speed, int spinning){
        double varPart = 1 / Math.exp(Math.pow(speed.abs() / slipDelay, gripLin * 2));
        return speed.scale((varPart * (1 - minGrip) * (1 - 0.5 * spinning) + minGrip) * maxGrip).invert();
    }
    public double spinning(Vector speed, int spinning){
        double varPart = 1 / Math.exp(Math.pow(speed.abs() / slipDelay, gripLin * 2));
        return 1 - varPart;
    }
}